<?php

namespace STM\DB\SQL;

use \Exception;

/**
 * Test class for SelectQuery.
 * Generated by PHPUnit on 2011-08-18 at 11:46:59.
 * @group database
 */
class SelectQueryTest extends \PHPUnit_Framework_TestCase {

    private $object;
    private $bad_values;

    protected function setUp() {
        $this->object = new SelectQuery('table');
        $this->bad_values = array(null, false, array(), 0, 235, new Exception());
    }

    protected function tearDown() {
        
    }

    public function testGenerate() {
        $this->assertTrue(is_string($this->object->generate()));
        // bad tables names in construct
        foreach ($this->bad_values as $value) {
            $query = new SelectQuery($value);
            $this->assertFalse($query->generate());
        }
    }

    public function testSet_columns() {
        foreach ($this->bad_values as $value) {
            $this->object->setColumns($value);
            $this->assertTrue(is_string(strstr($this->object->generate(), 'SELECT *')));
        }
        $this->object->setColumns('dsadsa');
        $this->assertFalse(strstr($this->object->generate(), 'SELECT *'));
        $this->object->resetColumns();
        
        $this->object->setColumns(array('dsadsa'));
        $this->assertFalse(strstr($this->object->generate(), 'SELECT *'));
        $this->object->resetColumns();
        
        $this->object->setColumns(array('dsadsa' => 'das'));
        $this->assertFalse(strstr($this->object->generate(), 'SELECT *'));
        $this->object->resetColumns();
        // column (values) must be string
        $this->object->setColumns(array(355));
        $this->assertTrue(is_string(strstr($this->object->generate(), 'SELECT *')));
        // if alias is not string, then column is added withou alias
        $this->object->setColumns(array(355 => 'dsadsa'));
        $this->assertFalse(strstr($this->object->generate(), 'SELECT *'));
    }

    public function testResetColumns() {
        $this->object->setColumns(array('dsa'));
        $this->assertFalse(strstr($this->object->generate(), 'SELECT *'));
        $this->object->resetColumns();
        $this->assertTrue(is_string(strstr($this->object->generate(), 'SELECT *')));
    }

    public function testSet_table() {        
        foreach ($this->bad_values as $value) {            
            $query = new SelectQuery($value);
            $this->assertFalse($query->generate());
        }
    }

    public function testSet_join_tables() {
        foreach ($this->bad_values as $value) {  
            $this->object->setJoinTables(new JoinTable($value, 'matches', '1 = 1'));
            $this->assertFalse(strstr($this->object->generate(), 'JOIN'));
        }
        $this->object->setJoinTables(new JoinTable(JoinType::LEFT, 'matches', '...'));
        $this->object->setJoinTables(new JoinTable(JoinType::RIGHT, 'competitions', '...'));
        $this->assertTrue(is_string(stristr($this->object->generate(), 'LEFT JOIN')));
        $this->assertTrue(is_string(stristr($this->object->generate(), 'RIGHT JOIN')));
    }

    public function testSet_where() {
        $this->object->setWhere(new Condition(''));
        $this->assertFalse(strstr($this->object->generate(), 'WHERE'));
        
        $this->object->setWhere(new Condition('id is not null'));
        $this->assertTrue(is_string(strstr($this->object->generate(), 'WHERE')));
    }

    public function testSet_group_by() {
        foreach ($this->bad_values as $value) {            
            $this->object->setGroupBy($value);
            $this->assertFalse(strstr($this->object->generate(), 'GROUP BY'));
        }
    }

    public function testsetHaving() {
        foreach ($this->bad_values as $value) {            
            $this->object->setHaving($value);
            $this->assertFalse(strstr($this->object->generate(), 'HAVING'));
        }
        $this->object->setHaving(new Condition(''));
        $this->assertFalse(strstr($this->object->generate(), 'HAVING'));
        
        $this->object->setHaving(new Condition('count(id) > 5'));
        $this->assertTrue(is_string(strstr($this->object->generate(), 'HAVING')));
    }

    public function testSet_order_by() {
        foreach ($this->bad_values as $value) {            
            $this->object->setOrderBy($value);
            $this->assertFalse(strstr($this->object->generate(), 'ORDER BY'));
        }
    }

    public function testClear_query() {
        $this->object->clearQuery();
        $this->assertFalse($this->object->generate());
    }

    public function test__toString() {
        foreach($this->bad_values as $value) {
            $query = new SelectQuery($value);
            $this->assertTrue(strlen($query->__toString()) == 0);
        }
        
        $this->assertTrue(strlen($this->object->__toString()) > 0);
        $this->object->clearQuery();
        $this->assertTrue(strlen($this->object->__toString()) == 0);
                       
    }

}

?>
